#  Benchmarking Suite
#  Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#  http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

tool: Sysbench CPU
version: 0
revision: 1

driver: jb-workload

license: Mozilla Public License 2.0 ("MPL"), the GNU General Public License version 2 ("GPL") and the Apache License version 2 ("ASL")
license-url: https://github.com/rabbitmq/rabbitmq-perf-test/blob/main/LICENSE

maintainer-name: Gabriele Giammatteo
maintainer-email: gabriele.giammatteo@eng.it

references:
  homepage: https://github.com/akopytov/sysbench
  license: https://github.com/akopytov/sysbench/blob/master/COPYING

categories:
  - cpu
  - prime-numbers
  - cpu-intensive

jobs:
  - phase: prepare
    type: batch
    forms:
      shell:
        command: |
          sudo DEBIAN_FRONTEND=noninteractive apt-get -yq update
          sudo DEBIAN_FRONTEND=noninteractive apt-get -yq install sysbench
          sysbench $TEST prepare $OPTIONS || echo "not implemented"

  - phase: run
    type: batch
    parser: sysbench-cpu
    forms:
      shell:
        command: for i in $N_THREADS; do echo "###$TEST###$i###"; sysbench $TEST run --time=0 --threads=$i $OPTIONS  || exit 1; echo "###END###"; done
      container:
        image: severalnines/sysbench
        shellCmd: for i in $N_THREADS; do echo "###$TEST###$i###"; sysbench $TEST run --time=0 --threads=$i $OPTIONS  || exit 1; echo "###END###"; done

performance-index: events_rate_8

workloads:
  CPU 1k:
    version: 0.1-b
    env:
      N_THREADS: 1 2 4 8
      TEST: cpu
      OPTIONS: --cpu-max-prime=20000 --events=1000
  CPU 10k:
    env:
      N_THREADS: 1 2 4 8
      TEST: cpu
      OPTIONS: --cpu-max-prime=20000 --events=10000
  max10k-time90:
    env:
      N_THREADS: 8
      TEST: cpu
      OPTIONS: --cpu-max-prime=10000 --time=90
